#Load classic functions
source("Classic2_Rfunction.R")
source("Classic1_Rfunction.R")
source("greedyClassic2_Rfunction.R")
source("greedyClassic1_Rfunction.R")
source("suppITP1new.r")

##function to generate data
gendata <- function(exnum,seednum,n,d,impcoef)
{set.seed(seednum)
 d0 = length(impcoef)
 if (exnum==1)
 { x<- matrix(rnorm(n*d,mean=0,sd=1),n,d)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- exp(logodd)/(1+exp(logodd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==2)
 { x<- matrix(rnorm(n*d,mean=0,sd=1),n,d)
   x[,1] <- x[,1]+1
   x[,2] <- x[,2]-1
   beta <- impcoef
   if (d>d0) 
   {
   beta <- c(impcoef, rep(0,d-d0))
   }
   logodd <- 0.5+x%*%beta
   prob <- exp(logodd)/(1+exp(logodd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==3)
 {npos = floor(n/2)
  nneg = n-npos
  yx <- matrix(0,n,d+1)
  y <- c(rep(1,npos),rep(-1,nneg))
  yx[,1] <- y
  p <- runif(n)
  yx[,2] <- (p<=0.7)*y*(3+rnorm(n))+(p>0.7)*rnorm(n)
  yx[,3] <- (p<=0.7)*rnorm(n)+(p>0.7)*y*(rnorm(n)+3)
  if (d>d0)
  {
  yx[,(d0+2):(d+1)] <- matrix(rnorm(n*(d-d0),mean=0,sd=20),n,d-d0)
  }
 }
 if (exnum==4)
 {npos = floor(n/2)
  nneg = n-npos
  yx <- matrix(0,n,d+1)
  yx[,1] <- c(rep(1,npos),rep(-1,nneg))
  yx[,2] <- yx[,1]*rnorm(n,mean=3,sd=1)
  yx[,3] <- yx[,1]*rnorm(n,mean=6,sd=1)
  yx[,4] <- yx[,1]*rnorm(n,mean=9,sd=1)
  if (d>d0)
  {
  yx[,(d0+2):(d+1)] <- matrix(rnorm(n*(d-d0),mean=0,sd=20),n,d-d0)
  }
 }
 if (exnum==5)
 { x<- genmix51(n,d,d0)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- exp(logodd)/(1+exp(logodd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==6)  #AR(1)
 { Xtr <-matrix(rnorm(n*d),n,d)
   XS <- genS(d,d0,0.5,ctype=3)
   x <- Xtr%*%XS
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- exp(logodd)/(1+exp(logodd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
if (exnum==7)
 { x<- matrix(rnorm(n*d,mean=0,sd=1),n,d)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- pnorm(logodd)
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
if (exnum==8)  #probit, Mixture structure
 { x<- genmix51(n,d,d0)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- pnorm(logodd)
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==9)  #probit, AR(1)
 { Xtr <-matrix(rnorm(n*d),n,d)
   XS <- genS(d,d0,0.5,ctype=3)
   #XS <- S
   x <- Xtr%*%XS
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- pnorm(logodd)
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
if (exnum==10)  #1-probit, Mixture structure
 { x<- genmix51(n,d,d0)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- 1-pnorm(logodd)
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==11)  #1-probit, AR(1)
 { Xtr <-matrix(rnorm(n*d),n,d)
   XS <- genS(d,d0,0.5,ctype=3)
   x <- Xtr%*%XS
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   prob <- 1-pnorm(logodd)
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 }
 if (exnum==12)  #1-probit, Mixture structure
 { x<- genmix51(n,d,d0)
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   todd <- qnorm(dt(logodd, df=2))
   prob <- exp(todd)/(1+exp(todd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 } 
 if (exnum==13)  #1-probit, AR(1)
 { Xtr <-matrix(rnorm(n*d),n,d)
   XS <- genS(d,d0,0.5,ctype=3)
   x <- Xtr%*%XS
   beta <- c(impcoef, rep(0,d-d0))
   logodd <- x%*%beta
   todd <- qnorm(dt(logodd, df=2))
   prob <- exp(todd)/(1+exp(todd))
   y <- 2*(runif(n)<prob)-1
   yorder <- order(y,decreasing=T)
   y <- y[yorder]
   x <- x[yorder,]
   yx <- cbind(y,x)
 } 
yx
}


#generate mixture structure with rho1=0.9, rho2=0.6, rho=0.3)
genmix51 <- function(n,d,d0)
{ rhos = c(0.9, 0.7, 0.5)
  Utr<-matrix(rnorm(n*d),n,d)
  Wtr<-matrix(rnorm(n*d),n,d)
  WS <- genS(d,d0,rhos[3],ctype=2)
  Wtr <- Wtr%*%WS
  Ximp <- sqrt(1-rhos[1]^2)*Utr[,1:d0]+rhos[1]*Wtr[,1:d0]
  Xnon <- sqrt(1-rhos[2]^2)*Utr[,-(1:d0)]+rhos[2]*Wtr[,-(1:d0)]
  Xtr <- cbind(Ximp, Xnon)
  return(Xtr)
}





tuneSolve <- function(x,y,xtune,ytune,lam1,lam2,M,method) #lam1 and KK have same length
{
 d <- dim(x)[2]
 mmQ <- length(lam1)
 nn <- length(lam2)
 tunerr <- matrix(100,mmQ,nn)
 coefs <- rep(0,d)
 varlist <- rep(0,d)
 for (ii in 1:mmQ)
 { for (jj in 1:nn)
   { if (method=="QP")
      {select1 <- firstcalQP2(x,y,lam1[ii],lam2[jj],M)}
     if (method=="IT")
      {select1 <- firstcal(x,y,lam1[ii],lam2[jj],M)}
     if (method=="IT2")
      {select1 <- firstcal2(x,y,lam1[ii],lam2[jj],M)}
   sid1 <- unique(select1[,1])
   size1 <- length(sid1)-1
   beta1 = rep(0,d)
   for (j in 1:size1)
    {beta1[sid1[j]]=sum(select1[select1[,1]==sid1[j],2])}
   bb0 <- select1[M+1,2]
   tunerr[ii,jj] <- mean(ytune!=(2*(xtune%*%beta1+bb0>0)-1))
   }
}
   #choose the best tuning parameter
   bindex = which.min(tunerr)
   bestcol=ceiling(bindex/mmQ)
   bestrow =bindex-floor(bindex/mmQ)*mmQ
   if (bestrow==0) {bestrow = mmQ}
   bestlam2= lam2[bestcol]
   bestlam1 = lam1[bestrow]

  #final performance
  if (method=="QP")
      {bestsol <- firstcalQP2(x,y,bestlam1,bestlam2,M)}
  if (method=="IT")
      {bestsol <- firstcal(x,y,bestlam1,bestlam2,M)}
  if (method=="IT2")
      {bestsol <- firstcal2(x,y,bestlam1,bestlam2,M)}

  selid <- unique(bestsol[,1])
  msize <- length(selid)-1
  coefs <- rep(0,d)
  for (j in 1:msize)
   {coefs[selid[j]]=sum(bestsol[bestsol[,1]==selid[j],2])
    varlist[selid[j]]=1
   }  
  intcept <- bestsol[M+1,2]
  result <- list(coefs=coefs,intcept=intcept,varlist=varlist, bestcol=bestcol, bestrow=bestrow, tunerr=tunerr)
  return(result)
}


tuneSolve1 <- function(x,y,xtune,ytune,lam1,M,method,ep=1e-8) #lam1 for Power 1, no lambda2
{
 lam2.leng <- 10	
 d <- dim(x)[2]
 mmQ <- length(lam1)
 tunerr <- rep(100,mmQ)
 varlist <- rep(0,d)
 for (ii in 1:mmQ)
 { #print(ii)
 	#print(lam1[ii])
   if (method=="ITP1")
      {select1 <- firstcalP1(x,y,lam1[ii],M)}
   if (method=="ITP1new")
      {select1 <- firstcalP1new(x,y,lam1[ii],M)}
   if (method=="ITP1new2_brad")
      {	
      	select1 <- classic1(x,y,lam1[ii], epsilon=ep, M)
      	#select1 <- firstcalP1new2(x,y,lam1[ii],M)
      }
   if (method=="ITP1new2_bradgreed")
      {	
      	select1 <- gclassic1(x,y,lam1[ii], epsilon=ep, M)
      	#select1 <- firstcalP1new2(x,y,lam1[ii],M)
      }   
   if (method=="ITP1new2")
   	  {
   	  	select1 <- firstcalP1new2(x,y,lam1[ii],M)	
   	  }   
   if (method=="ITL")
      {select1 <- firstcal(x,y,lam1[ii],0,M)}
   if (method=="IT2L_brad")
      {select1 <- classic2( x, y, lam1[ii], 0, epsilon=ep, M)
      	#select1 <- firstcal2(x,y,lam1[ii],0,M)
      }
	if (method=="IT2L_bradgreed")
      {select1 <- gclassic2( x, y, lam1[ii], 0, epsilon=ep, M)
      	#select1 <- firstcal2(x,y,lam1[ii],0,M)
      }
    if (method=="IT2L")
      { 
      select1 <- firstcal2(x,y,lam1[ii],0,M)
      }   
   if (method=="ITLR")
      {select1 <- firstcalR(x,y,lam1[ii],0,M)}
   if (method=="IT2LR")
      {select1 <- firstcal2R(x,y,lam1[ii],0,M)}
   if (method=="ITP1newR")
      {select1 <- firstcalP1newR(x,y,lam1[ii],M)}
   if (method=="ITP1new2R")
      {select1 <- firstcalP1new2R(x,y,lam1[ii],M)}

   sid1 <- unique(select1[,1])
   numpick <- length(select1[,1])
   size1 <- length(sid1)-1
   beta1 = rep(0,d)
   for (j in 1:size1)
    {beta1[sid1[j]]=sum(select1[select1[,1]==sid1[j],2])}
   bb0 <- select1[numpick,2]
   tunerr[ii] <- mean(ytune!=(2*(xtune%*%beta1+bb0>0)-1))
 }
   #choose the best tuning parameter
   bindex = which.min(tunerr)
   bestlam1= lam1[bindex]
   
if(bindex==1){
	lam2 = seq( 0, lam1[bindex], l=lam2.leng)
}else if(bindex==length(lam1) ){
	lam2 = seq( lam1[bindex], lam1[bindex]+1000, l=lam2.leng)
}else{
	lam2 = seq( lam1[bindex-1], lam1[bindex+1], l=lam2.leng)
}
cat(lam2, "\n")

 tunerr2 <- rep(100,lam2.leng)
#tune again
for (ii in 1:lam2.leng)
 { #print(ii)
 	#print(lam1[ii])
   if (method=="ITP1")
      {select2 <- firstcalP1(x,y,lam2[ii],M)}
   if (method=="ITP1new")
      {select2 <- firstcalP1new(x,y,lam2[ii],M)}
   if (method=="ITP1new2_brad")
      {	
      	select2 <- classic1(x,y,lam2[ii], epsilon=ep, M)
      	#select1 <- firstcalP1new2(x,y,lam1[ii],M)
      }
	if (method=="ITP1new2_bradgreed")
      {	
      	select2 <- gclassic1(x,y,lam2[ii], epsilon=ep, M)
      	#select1 <- firstcalP1new2(x,y,lam1[ii],M)
      }
   if (method=="ITP1new2")
   	  {
   	  	select2 <- firstcalP1new2(x,y,lam2[ii],M)	
   	  }   
   if (method=="ITL")
      {select2 <- firstcal(x,y,lam2[ii],0,M)}
   if (method=="IT2L_brad")
      {select2 <- classic2( x, y, lam2[ii], 0, epsilon=ep, M)
      	#select1 <- firstcal2(x,y,lam1[ii],0,M)
      }
    if (method=="IT2L_bradgreed")
      {select2 <- gclassic2( x, y, lam2[ii], 0, epsilon=ep, M)
      	#select1 <- firstcal2(x,y,lam1[ii],0,M)
      }  
    if (method=="IT2L")
      { 
      select2 <- firstcal2(x,y,lam2[ii],0,M)
      }   
   if (method=="ITLR")
      {select2 <- firstcalR(x,y,lam2[ii],0,M)}
   if (method=="IT2LR")
      {select2 <- firstcal2R(x,y,lam2[ii],0,M)}
   if (method=="ITP1newR")
      {select2 <- firstcalP1newR(x,y,lam2[ii],M)}
   if (method=="ITP1new2R")
      {select2 <- firstcalP1new2R(x,y,lam2[ii],M)}

   sid2 <- unique(select2[,1])
   numpick <- length(select2[,1])
   size2 <- length(sid2)-1
   beta2 = rep(0,d)
   for (j in 1:size2)
    {beta2[sid2[j]]=sum(select2[select2[,1]==sid2[j],2])}
   bb0 <- select2[numpick,2]
   tunerr2[ii] <- mean(ytune!=(2*(xtune%*%beta2+bb0>0)-1))
 }
   #choose the best tuning parameter
   bindex2 = which.min(tunerr2)
   bestlam2= lam2[bindex2]
   

  #final performance
  if (method=="ITP1")
      {bestsol <- firstcalP1(x,y,bestlam2,M)}
  if (method=="ITP1new")
      {bestsol <- firstcalP1new(x,y,bestlam2,M)}
  if (method=="ITP1new2_brad")
      { bestsol <- classic1(x,y,bestlam2, epsilon=ep,M)
      	#bestsol <- firstcalP1new2(x,y,bestlam1,M)
      	}
   if (method=="ITP1new2_bradgreed")
      { bestsol <- gclassic1(x,y,bestlam2, epsilon=ep,M)
      	#bestsol <- firstcalP1new2(x,y,bestlam1,M)
      	}   	
  if (method=="ITP1new2")
   	  {
   	  	bestsol <- firstcalP1new2(x,y,bestlam2,M)	
   	  }       	
  if (method=="ITL")
      {bestsol <- firstcal(x,y,bestlam2,0,M)}
  if (method=="IT2L_brad")
      { bestsol <- classic2( x, y, bestlam2, 0, epsilon=ep, M)
      	#bestsol <- firstcal2(x,y,bestlam1,0,M)
      	}
   if (method=="IT2L_bradgreed")
      { bestsol <- gclassic2( x, y, bestlam2, 0, epsilon=ep, M)
      	#bestsol <- firstcal2(x,y,bestlam1,0,M)
      	}   	
  if (method=="IT2L")
      { 
      bestsol <- firstcal2(x,y,bestlam2,0,M)
      	}    	
  if (method=="ITLR")
      {bestsol <- firstcalR(x,y,bestlam2,0,M)}
  if (method=="IT2LR")
      {bestsol <- firstcal2R(x,y,bestlam2,0,M)}
  if (method=="ITP1newR")
      {bestsol <- firstcalP1newR(x,y,bestlam2,M)}
  if (method=="ITP1new2R")
      {bestsol <- firstcalP1new2R(x,y,bestlam2,M)}

  selid <- unique(bestsol[,1])
  numpick <- length(bestsol[,1])
  msize <- length(selid)-1
  coefs <- rep(0,d)
  for (j in 1:msize)
   {coefs[selid[j]]=sum(bestsol[bestsol[,1]==selid[j],2])
    varlist[selid[j]]=1
   }  
  intcept <- bestsol[numpick,2]
  result <- list(coefs=coefs,intcept=intcept,M=(numpick-1),varlist=varlist, bindex=bindex, tunerr=tunerr)
  return(result)
}


### for Y=0 and 1, type I error, type II error,
finalsum <- function(coefs, intcept, impid, xtest, ytest)
 { testerr <- mean(ytest!=(2*((xtest%*%coefs+intcept)>0)-1))
   selecterr <- c(sum(coefs[impid]==0),sum(coefs[-impid]!=0))
   result <- c(testerr, selecterr)
   return(result)
 }

## variable selection summary
varsum <- function(coefs, impid)
 { selecterr <- c(sum(coefs[impid]==0),sum(coefs[-impid]!=0))
   return(selecterr)
 }


##specify correlation matrix (CS strcture)
## input: p = total dimension, q = number of important variables
##        opt = 1 ( CS(rho) structure among important X)
##        opt = 2 ( CS(rho) structure among all X)
##        opt = 3 ( AR(rho) among all X)
genCorr <- function(p,q,rho,opt){
  Xcorr<-matrix(0,p,p)
  if (opt==1)
  { for (i in 1:q)
    {  for (j in 1:q)
       { if(j==i){Xcorr[i,j]<-1}
         else{Xcorr[i,j]<-rho}
       }
    }
    for (i in (q+1):p)
    {  Xcorr[i,i]<-1 }
  }
  if (opt==2)
  { for (i in 1:p)
    {  for (j in 1:p)
       { if(j==i){Xcorr[i,j]<-1}
         else{Xcorr[i,j]<-rho}
       }
    }
  }
  if (opt==3)
  {  V <- rep(1,p)
     for (j in 2:p) 
     {  V[j] <- rho^(j-1)
     }
     tmp <- diag(rep(1/2,p))
     for (i in 1:(p-1))
     {  tmp[i,(i+1):p] <- V[2:(1+p-i)]
     }
     Xcorr <- tmp+t(tmp)
  	 # vals <- 1:p
	 # H <- abs(outer(vals, vals, "-"))
	 # Xcorr2 <- rho^H
  }
  return(Xcorr)
}

#genS: p*p matrix
#generate X with Corr=genCorr, marginal variance=1
#X=matrix(rnorm(n*p),n,p)%*%S
genS <- function(p,q,rho,ctype)
{ Xcov <- genCorr(p,q,rho,ctype)
  svd.Xcov<-svd(Xcov)
  v<-svd.Xcov$v
  d<-svd.Xcov$d
  D<-diag(sqrt(d))
  S<-(v)%*%D%*%t(v)
  return(S)
}
#generate X with Corr=genCorr, marginal variance=1
#X=matrix(rnorm(n*p),n,p)%*%S

## objective function + power 2. x = (alpha, beta_1, ..., beta_p)
fobj2 <- function(bb,ylab,xinput,tau1,tau2)
{ n <- length(ylab)
  XX <- cbind(rep(1,n),xinput)
  sum(pmax(0,1-ylab*(XX%*%bb))^2)+tau1*sum(abs(bb))+tau2*sum(bb^2)
}

fobj1 <- function(bb,ylab,xinput,tau1)
{ n <- length(ylab)
  XX <- cbind(rep(1,n),xinput)
  sum(pmax(0,1-ylab*(XX%*%bb)))+tau1*sum(abs(bb))
}
