##function to compute betaj, note xj is one dimensional

sbeta <- function(cc,xj,y,lama1,lama2)
####IMPORTANT: call this function, y need to be sorted as [+1,..,+1,-1,...-1], "
####DECREASING"
####cc, xj, y all have length n
{n = length(y)
 n1 = sum(y>0)
 posc = pmax(0,cc)
 cxprod = cc*xj  
 xjsq = xj^2 ##xj^2
 nzid = (1:n)[xj!=0] #excluding x=0. The term with x_i=0 does not contribute 
                     #to either Even or Todd
 cdxy = cc[nzid]/(y[nzid]*xj[nzid]) ## unique knots
                     #there was a big bug before. I forgot "y"!
 posid = nzid[cdxy>0] ## allow ties
 negid = nzid[cdxy<0] ## allow ties
 posBB = sort(unique(cdxy[posid]),decreasing=F)  #remove ties
 negBB = sort(unique(cdxy[negid]),decreasing=T) 
 posn <- length(posBB) 
 negn <- length(negBB)

#four index sets, subsets of {1,...,n}
#posx1 = {y==+1, x>0}, negx1 = {y==+1, x<0}, posx2 = {y==-1, x>0}, negx2 = {y==-1, x<0}
 posx1 = (1:n1)[xj[1:n1]>0]
 negx1 = (1:n1)[xj[1:n1]<0]
 posx2 = ((n1+1):n)[xj[(n1+1):n]>0]
 negx2 = ((n1+1):n)[xj[(n1+1):n]<0]

 #compute the ratio of c and x, except x=0
 cdx = rep(0,n)
 cdx[posx1] = cc[posx1]/xj[posx1]
 cdx[negx1] = cc[negx1]/xj[negx1]
 cdx[posx2] = cc[posx2]/xj[posx2]
 cdx[negx2] = cc[negx2]/xj[negx2] 

 ##compute the derivative of zero
 ##initial set:S1=intersect(posx1,(1:n)[cdx>=0]),S2=intersect(posx2,(1:n)[cdx>=0]),
 ##            S3=intersect(negx1,(1:n)[cdx<=0]),S4=intersect(negx2, (1:n)[cdx<=0])
 ##T1,T2,T3,T4 are for x>0, and T5,T6,T7,T8 are for x<0
 #T1 = sum(cxprod[S1]),T2 = sum(xjsq[S1]),T3 = sum(cxprod[S2]),T4 = sum(xjsq[S2])
 #T5 = sum(cxprod[S3]),T6 = sum(xjsq[S3]),T7 = sum(cxprod[S4]),T8 = sum(xjsq[S4])
 #T1 = sum((cxprod*(cdx>=0))[posx1])
 #T2 = sum((xjsq*(cdx>=0))[posx1])
 #T3 = sum((cxprod*(cdx>=0))[posx2])
 #T4 = sum((xjsq*(cdx>=0))[posx2])
 #T5 = sum((cxprod*(cdx<=0))[negx1])
 #T6 = sum((xjsq*(cdx<=0))[negx1])
 #T7 = sum((cxprod*(cdx<=0))[negx2])
 #T8 = sum((xjsq*(cdx<=0))[negx2])
 #oTodd = -T1+T3-T5+T7
 #oTeven = T2+T4+T6+T8
 #rdev0 = 2*(-T1+T3-T5+T7)+lama1
 rdev0 <- -2*sum(posc*y*xj)+lama1 #fast version
 ldev0 <- rdev0-2*lama1

 ##compute the derivative of Bmax and Bmin=-Bmax
 if (posn>0)
  {Bmax = posBB[posn]
   devBmax <- -2*sum(cxprod[negx1]-Bmax*xjsq[negx1])+2*sum(cxprod[posx2]+Bmax*xjsq[posx2])+lama1+2*lama2*Bmax
  }
 if (posn==0)
  {Bmax = 0
   devBmax = ldev0
  }
  
 if (negn>0)
   {Bmin = negBB[negn]
   devBmin <- -2*sum(cxprod[posx1]-Bmin*xjsq[posx1])+2*sum(cxprod[negx2]+Bmin*xjsq[negx2])-lama1+2*lama2*Bmin
   }
 if (negn==0)
   {Bmin = 0
    devBmin = rdev0
   }

 ##search for the best solution
 ##Case1 :
 if (ldev0*rdev0<=0) 
  {iter = 1
   minbeta=0
  }
 ##Case 2:
 if (ldev0>0 & devBmin>=0) 
  {iter=1
   minbeta=Bmax-devBmax/(2*(sum(xjsq[c(negx1,posx2)])+lama2))
  }
 ##Case 3:
 if (rdev0<0 & devBmax<=0) 
  {iter =1
   minbeta=Bmin+devBmin/(2*(sum(xjsq[c(posx1,negx2)])+lama2))
  }
 ##Case 4:
 if (rdev0<0 & devBmax>0) ## search on the positive part
  {newBB1 = posBB[1]
   S1=posx1[cdx[posx1]>=newBB1]
   S2=negx1[cdx[negx1]<=newBB1]
   S3=posx2[cdx[posx2]>=-newBB1]
   S4=negx2[cdx[negx2]<=-newBB1]
   #S1=intersect(posx1,(1:n)[cdx>=newBB1])
   #S2=intersect(negx1,(1:n)[cdx<=newBB1])
   #S3=intersect(posx2,(1:n)[cdx>=-newBB1])
   #S4=intersect(negx2,(1:n)[cdx<=-newBB1])
   Todd1 = -sum(cxprod[S1])-sum(cxprod[S2])+sum(cxprod[S3])+sum(cxprod[S4])
   Teven1 = sum(xjsq[c(S1,S2,S3,S4)])
   newdev1 <- 2*(Todd1+newBB1*Teven1+lama2*newBB1)+lama1
   if (newdev1==0)
    {iter = 2
     minbeta=newBB1
    }
   else if (newdev1>0) 
    {iter = 2
     minbeta=crossz(0,rdev0,newBB1,newdev1)
    }
   else 
    {k=1   #skip the first one, which is specially handled
     newBB = newBB1
     newdev = newdev1
     oTodd = Todd1
     oTeven = Teven1
     while (newdev<0)
     {oldBB <- newBB
      olddev <- newdev
      k <- k+1
      newBB <- posBB[k]
      J1 <- posx1[cdx[posx1]==oldBB]
      J2 <- negx1[cdx[negx1]==newBB]
      J3 <- posx2[cdx[posx2]==-newBB]
      J4 <- negx2[cdx[negx2]==-oldBB]
      
      #compute new derivative
      nTodd <- oTodd+sum(cxprod[c(J1,J3)])-sum(cxprod[c(J2,J4)])
      nTeven <- oTeven+sum(xjsq[c(J2,J3)])-sum(xjsq[c(J1,J4)])
      newdev <- 2*(nTodd+newBB*nTeven+lama2*newBB)+lama1
      #retain old values for update
      oTodd <- nTodd
      oTeven <- nTeven
      }
    #print(paste("positive search: k=",eval(k),sep=""))
     if (newdev==0) 
     {iter = k
      minbeta = newBB
     }
     if (newdev>0) 
     {iter = k
      minbeta=crossz(oldBB,olddev,newBB,newdev)
     }
    }
  }
 ##Case 5:
 if (ldev0>0 & devBmin<0)  ## search on the negative part
  {#calculate the first one on the left, need special handling
   newBB1 = negBB[1]
   S1=posx1[cdx[posx1]>=newBB1]
   S2=negx1[cdx[negx1]<=newBB1]
   S3=posx2[cdx[posx2]>=-newBB1]
   S4=negx2[cdx[negx2]<=-newBB1]
   #S1=intersect(posx1,(1:n)[cdx>=newBB1])
   #S2=intersect(negx1,(1:n)[cdx<=newBB1])
   #S3=intersect(posx2,(1:n)[cdx>=-newBB1])
   #S4=intersect(negx2,(1:n)[cdx<=-newBB1])
   oTodd = -sum(cxprod[S1])-sum(cxprod[S2])+sum(cxprod[S3])+sum(cxprod[S4])
   oTeven = sum(xjsq[c(S1,S2,S3,S4)])
   newdev1 <- 2*(oTodd+newBB1*oTeven+lama2*newBB1)-lama1
   if (newdev1<0) 
    {iter = 2
     minbeta=crossz(0,ldev0,newBB1,newdev1)}
   else if (newdev1==0)
    {iter = 2
     minbeta = newBB1} 
   else 
   { k = 1
     newBB = newBB1
     newdev = newdev1
     while (newdev>0)
     { oldBB = newBB
       olddev = newdev
       k <- k+1
       newBB <- negBB[k]
       J1 <- posx1[cdx[posx1]==newBB]
       J2 <- negx1[cdx[negx1]==oldBB]
       J3 <- posx2[cdx[posx2]==-oldBB]
       J4 <- negx2[cdx[negx2]==-newBB]
      
       #compute new derivative
       nTodd <- oTodd+sum(cxprod[c(J2,J4)])-sum(cxprod[c(J3,J1)])
       nTeven <- oTeven+sum(xjsq[c(J1,J4)])-sum(xjsq[c(J3,J2)])
       newdev <- 2*(nTodd+newBB*nTeven+lama2*newBB)-lama1
     
       #retain old values for update
       oTodd <- nTodd
       oTeven <- nTeven
     }
     #print(paste("negative search: k=",eval(k),sep=""))
       if (newdev==0) 
       {iter = k
        minbeta=newBB
       }
       if (newdev<0) 
       {iter = k
        minbeta=crossz(oldBB,olddev,newBB,newdev)
       }
   }
  }
    z = list(minbeta = minbeta, iter=iter)
    return(z)
 }


#update intercept
sbeta0 <- function(cc,y)
 {n <- length(y)
  score <- sbeta(cc,rep(1,n),y,0,0)
  z = list(minbeta=score[[1]], iter=score[[2]])
  return(z)
 }

#find the minimzer using interpolation
crossz <- function(x1,y1,x2,y2)
{ rr <- (y2-y1)/(x2-x1)
  myroot <- x1-y1/rr
  return(myroot)
}


## select the best variable: fast version (matrix computation)
selectbeta <- function(cc,x,y,betas,lama1,lama2)
{d <- length(betas)
 CC <- matrix(rep(cc,d),n,d)
 obj0 <- (pmax(CC-x*(matrix(y,n,1)%*%matrix(betas,1,d)),0))^2
 objval <- apply(obj0,2,sum)+lama1*abs(betas)+lama2*betas^2
 index <- which.min(objval)
 return(index)
}

#select the best variable: slow version
#selectbeta2 <- function(cc,x,y,betas,lama1,lama2)
#{d <- length(betas)
#  objval <- rep(0,d)
#  for (j in 1:d)
#  {objval[j] <- sum(pmax(0,cc-y*x[,j]*betas[j])^2)+lama1*abs(betas[j])+lama2*betas[j]^2}
# index <- which.min(objval)
#}

 
## FIRSTCAL functions: update beta0 at each iteration
firstcal <- function(x,y,lama1,lama2,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 = (n1-n2)/n     #initial beta0
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0)^2)/n
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbeta(cc,xj=x[,j],y=y,lama1,lama2)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbeta(cc,x,y,betas,lama1,lama2)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  ##update beta0
  beta0 = sbeta0(cc,y)[[1]]
  #print(paste("beta0=",round(eval(beta0),4),sep=" "))
  cc = cc-y*beta0
  newobj = sum(pmax(cc,0)^2)/n
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }

  beta0 = sbeta0(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
  selectvar[M+1,1]=0
  selectvar[M+1,2]=beta0
  return(selectvar)
}

## FIRSTCAL2 functions: do not update beta0 at each step
firstcal2 <- function(x,y,lama1,lama2,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 = (n1-n2)/n     #initial beta0
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0)^2)/n
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbeta(cc,x[,j],y,lama1,lama2)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbeta(cc,x,y,betas,lama1,lama2)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  newobj = sum(pmax(cc,0)^2)/n
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }

  beta0 = beta0 + sbeta0(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
  selectvar[M+1,1]=0
  selectvar[M+1,2]=beta0
  return(selectvar)
}


 
## FIRSTCAL+Refitting at the final step: update beta0 at each iteration
firstcalR <- function(x,y,lama1,lama2,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 = (n1-n2)/n     #initial beta0
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0)^2)/n
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbeta(cc,x[,j],y,lama1,lama2)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbeta(cc,x,y,betas,lama1,lama2)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  ##update beta0
  beta0 = sbeta0(cc,y)[[1]]
  #print(paste("beta0=",round(eval(beta0),4),sep=" "))
  cc = cc-y*beta0
  newobj = sum(pmax(cc,0)^2)/n
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }

  beta0 = sbeta0(cc,y)[[1]] #update b0 one more time

  #refit step
  sid1 <- sort(unique(selectvar[selectvar[,1]>0,1])) #selected variables index
  size1 <- length(sid1)
  value1 <- rep(0,size1) #the collected coefficients for selected variables
  freq1 <- rep(0,size1)  #the selection frequency for selected variables
  for (j in 1:size1)
    {value1[j]=sum(selectvar[selectvar[,1]==sid1[j],2])
     freq1[j] = sum(sid1[j]==selectvar[,1])
    } 

  xx <- x[,sid1]
  init1 <- c(beta0,value1)
  refits <- optim(init1,fn=fobj2, gr=NULL, ylab=y, xinput=xx, tau1=lama1,tau2=lama2, method="BFGS")$par

  for (ii in 1:(size1))
    { id = sid1[ii]
      selectvar[selectvar[,1]==id,2]=refits[1+ii]/freq1[ii]
    }
  selectvar[M+1,1]=0
  selectvar[M+1,2]=refits[1]
  return(selectvar)
}




## FIRSTCAL2+Refitting at the final step: do not update beta0 at each step
firstcal2R <- function(x,y,lama1,lama2,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 = (n1-n2)/n     #initial beta0
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0)^2)/n
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbeta(cc,x[,j],y,lama1,lama2)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbeta(cc,x,y,betas,lama1,lama2)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  newobj = sum(pmax(cc,0)^2)/n
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }

  beta0 = sbeta0(cc,y)[[1]] #update b0 one more time
  #refit step
  sid1 <- sort(unique(selectvar[selectvar[,1]>0,1])) #selected variables index
  size1 <- length(sid1)
  value1 <- rep(0,size1) #the collected coefficients for selected variables
  freq1 <- rep(0,size1)  #the selection frequency for selected variables
  for (j in 1:size1)
    {value1[j]=sum(selectvar[selectvar[,1]==sid1[j],2])
     freq1[j] = sum(sid1[j]==selectvar[,1])
    } 

  xx <- x[,sid1]
  init1 <- c(beta0,value1)
  refitff <- optim(init1,fobj2,gr=NULL,ylab=y,xinput=xx, tau1=lama1, tau2=lama2, method="BFGS")
  refits <- refitff$par
  refitobj <- refitff$value


  for (ii in 1:(size1))
    { id = sid1[ii]
      selectvar[selectvar[,1]==id,2]=refits[1+ii]/freq1[ii]
    }
  selectvar[M+1,1]=0
  selectvar[M+1,2]=refits[1]
  return(selectvar)
}


