##function to compute betaj, note xj is one dimensional
##based on the new derivation of svm hinge loss
##Feb, 11, 2011
sbetaP1new <- function(cc,xj,y,lama1)
####IMPORTANT: call this function, y is decreasing and sorted as [+1,..,+1,-1,...-1],
####the objective function: loss/n + lambda * penalty
####cc, xj, y all have length n
{n = length(y)
 n1 = sum(y>0)
 nzid = (1:n)[xj!=0] #excluding x=0. The term with x_i=0 does not contribute 
                     #to either Even or Todd
 cdxy = cc[nzid]/(y[nzid]*xj[nzid]) ## unique knots
                     #there was a big bug before. I forgot "y"!
 posid = nzid[cdxy>0] ## allow ties
 negid = nzid[cdxy<0] ## allow ties
 posBB = sort(unique(cdxy[posid]),decreasing=F)  #remove ties
 negBB = sort(unique(cdxy[negid]),decreasing=T) 
 posn <- length(posBB) 
 negn <- length(negBB)
 #uniq = round(unique(abs(cc[nzid]/xj[nzid])),8) #unique nonzero ratios
 #BB = sort(uniq) ## increasing order 0<BB[1]<...<BB[nuniq]
 #nuniq = length(uniq) #length of unique ratios

#four index sets, subsets of {1,...,n}. Their union does not include {x=0}
#posx1 = {y==+1, x>0}, negx1 = {y==+1, x<0}, posx2 = {y==-1, x>0}, negx2 = {y==-1, x<0}
 posx1 = (1:n1)[xj[1:n1]>0]
 negx1 = (1:n1)[xj[1:n1]<0]
 posx2 = ((n1+1):n)[xj[(n1+1):n]>0]
 negx2 = ((n1+1):n)[xj[(n1+1):n]<0]

 #compute the ratio of c and x, except x=0
 cdx = rep(0,n)
 cdx[nzid] = cc[nzid]/(xj[nzid]*y[nzid])

 ##compute the derivative of zero
 ##initial set:S1=intersect(posx1,(1:n)[cdx>=0]),S2=intersect(posx2,(1:n)[cdx>=0]),
 ##            S3=intersect(negx1,(1:n)[cdx<=0]),S4=intersect(negx2, (1:n)[cdx<=0])
 ##T1,T2,T3,T4 are for x>0, and T5,T6,T7,T8 are for x<0
 rdev0 = sum((-xj*(cc>0))[posx1])+sum((-xj*(cc>=0))[negx1])+sum((xj*(cc>=0))[posx2])+sum((xj*(cc>0))[negx2])+lama1
 ldev0 = sum((-xj*(cc>=0))[posx1])+sum((-xj*(cc>0))[negx1])+sum((xj*(cc>0))[posx2])+sum((xj*(cc>=0))[negx2])-lama1
 #cat( "F_0+=", rdev0, "\t F_0-=",ldev0, "\n")
 #rdev00 = sum(-xj*y*(cc>0))+sum((-xj*y*(cc==0))[negx1])+sum((-xj*y*(cc==0))[posx2])+lama1
 #ldev00 = sum(-xj*y*(cc>0))+sum((-xj*y*(cc==0))[posx1])+sum((-xj*y*(cc==0))[negx2])-lama1
 
 #print("rdev0, ldev0, rdev00, ldev00, lama1")
 #print(c(rdev0,ldev0,rdev00,ldev00,lama1))
  
 ##search for the best solution
 ##Case1 :
 if (ldev0<=0 & rdev0>=0) 
  {iter = 1
   minbeta=0
   obj = sum(pmax(0,cc))
  }
 ##Case 2:
 ## positive search: calculate only the right derivative
 ## the argmin is where right devivative become positive 
 if (rdev0<0) ## search on the positive part
  {k = 1
   newBB = posBB[1]
   newdev = rdev0+sum(abs(xj[cdx==newBB]))
   while (newdev < 0)
    { k = k+1
      olddev = newdev
      newBB = posBB[k]
      newdev = olddev+sum(abs(xj[cdx==newBB]))
    }
    iter = k+1  
    minbeta = newBB
    obj = sum(pmax(0,cc-y*xj*newBB))+lama1*newBB
   }
   
 ##Case 3:
 ## negative search: calculate only the left derivative
 ## the argmin is where left devivative become negative 
 if (ldev0>0) ## search on the positive part
  {k = 1
   newBB = negBB[1]
   newdev = ldev0-sum(abs(xj[cdx==newBB]))
   while (newdev > 0)
    { k = k+1
      olddev = newdev
      newBB = negBB[k]
      newdev = olddev -sum(abs(xj[cdx==newBB]))
      
    }
    iter = k+1  
    minbeta = newBB
    obj =  sum(pmax(0,cc-y*xj*newBB))-lama1*newBB
   }
   z = list(minbeta = minbeta, iter=iter, obj = obj)
   return(z)
 }

##function to update beta0: there is no penalty on beta0
sbeta0P1new <- function(cc,y)
 {n <- length(y)
  score <- sbetaP1new(cc,rep(1,n),y,0)
  z = list(minbeta=score[[1]], iter=score[[2]], obj=score[[3]])
  return(z)
 }

## select the best variable: fast version (matrix computation)
selectbetaP1new <- function(cc,x,y,betas)
{d <- length(betas)
 CC <- matrix(rep(cc,d),n,d)
 obj0 <- pmax(CC-x*(matrix(y,n,1)%*%matrix(betas,1,d)),0)
 objval <- apply(obj0,2,mean)
 index <- which.min(objval)
 return(index)
}


#select the best variable: slow version
#selectbetaP12 <- function(cc,x,y,betas,lama1,lam2)
#{d <- length(betas)
#  objval <- rep(0,d)
#  for (j in 1:d)
#  {objval[j] <- mean(pmax(0,cc-y*x[,j]*betas[j]))}
# index <- which.min(objval)
#}

## FIRSTCAL functions: update beta0 at each iteration
## Note the objective function is devided by n
firstcalP1new <- function(x,y,lama1,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 <- 1*(2*n1>n)+0*(2*n1==n)-1*(2*n1<n)  #initial beta0. Check this!
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0))
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbetaP1new(cc,x[,j],y,lama1)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbetaP1new(cc,x,y,betas)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  ##update beta0, Required for FIRSTCAL, not FIRST
  beta0 = sbeta0P1new(cc,y)[[1]]
  #print(paste("beta0=",round(eval(beta0),4),sep=" "))
  cc = cc-y*beta0
  newobj = sum(pmax(cc,0))
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }
  #print(paste("total numer of iterations",eval(iKK),sep=" "))

  #beta0 = sbeta0P1(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
  selectvar[M+1,1]=0
  selectvar[M+1,2]=beta0
  return(selectvar)
}

## FIRSTCAL functions: not update beta0 at each iteration
## Note the objective function is devided by n
firstcalP1new2 <- function(x,y,lama1,M)
{
 ##return a matrix of dim (M+1)*2
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 <- 1*(2*n1>n)+0*(2*n1==n)-1*(2*n1<n)  #initial beta0. Check this!
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0))
 newobj = 100

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbetaP1new(cc,x[,j],y,lama1)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbetaP1new(cc,x,y,betas)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  newobj = sum(pmax(cc,0))
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }
  #print(paste("total numer of iterations",eval(iKK),sep=" "))

  beta0 <- beta0 + sbeta0P1new(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
  selectvar[M+1,1]=0
  selectvar[M+1,2]=beta0
  return(selectvar)
}


 

 
## FIRSTCAL+Refitting: update beta0 at each iteration
## Note the objective function is devided by n
firstcalP1newR <- function(x,y,lama1,M)
{
 ##return a matrix of dim (M+1)*2
 myeps = 1e-4
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 <- 1*(2*n1>n)+0*(2*n1==n)-1*(2*n1<n)  #initial beta0. Check this!
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0))
 newobj = 1000

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbetaP1new(cc,x[,j],y,lama1)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbetaP1new(cc,x,y,betas)
  #print(paste("select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  ##update beta0, Required for FIRSTCAL, not FIRST
  beta0 = sbeta0P1new(cc,y)[[1]]
  #print(paste("beta0=",round(eval(beta0),4),sep=" "))
  cc = cc-y*beta0
  newobj = sum(pmax(cc,0))
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }
  #print(paste("total numer of iterations",eval(iKK),sep=" "))

  #beta0 = sbeta0P1(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
   
  #refit step
  sid1 <- sort(unique(selectvar[selectvar[,1]>0,1])) #selected variables index
  size1 <- length(sid1)
  value1 <- rep(0,size1) #the collected coefficients for selected variables
  freq1 <- rep(0,size1)  #the selection frequency for selected variables
  for (j in 1:size1)
    {value1[j]=sum(selectvar[selectvar[,1]==sid1[j],2])
     freq1[j] = sum(sid1[j]==selectvar[,1])
    } 

  xx <- as.matrix(x[,sid1])
  #init1 <- c(beta0,value1)
  #refitff <- optim(init1,fobj1,gr=NULL,ylab=y,xinput=xx, tau1=lama1, method="BFGS")
  #refits <- refitff$par
  #refitobj <- refitff$value

  svmfit1 <- svmpath(xx,y)
  if (lama1<min(svmfit1$lambda))
   {svmpred1 <- predict(svmfit1,lambda=min(svmfit1$lambda)+myeps,type="alpha") }
  if (lama1>max(svmfit1$lambda))
   {svmpred1 <- predict(svmfit1,lambda=max(svmfit1$lambda)+myeps,type="alpha")  }
  if (lama1>=min(svmfit1$lambda) & lama1<=max(svmfit1$lambda) ) 
   {svmpred1 <- predict(svmfit1,lambda=lama1,type="alpha")  }
  selectvar[M+1,1]=0
  selectvar[M+1,2]=svmpred1$alpha0
  refits <- t(xx)%*%(svmpred1$alpha*y)

  for (ii in 1:(size1))
    { idd = sid1[ii]
      selectvar[selectvar[,1]==idd,2]=refits[ii]/freq1[ii]
    }
  return(selectvar)
}



 
## FIRSTCAL functions: not update beta0 at each iteration
## Note the objective function is devided by n
firstcalP1new2R <- function(x,y,lama1,M)
{
 ##return a matrix of dim (M+1)*2
 myeps = 1e-4
 n <- length(y)
 d <- dim(x)[2]
 n1 = sum(y==1)
 n2 = n-n1
 beta0 <- 1*(2*n1>n)+0*(2*n1==n)-1*(2*n1<n)  #initial beta0. Check this!
 cc = rep(1,n)-y*beta0 #initial cc
 oldobj = sum(pmax(cc,0))
 newobj = 1000

 odiff = newobj-oldobj
 betas = rep(0,d)      #intermediate values
 selectvar = matrix(0,M+1,2)
 
 iKK=1
 while (iKK <= M &  abs(odiff)>1e-8) #iKK is the iteration number
 {for (j in 1:d)
   { betas[j] = sbetaP1new(cc,x[,j],y,lama1)[[1]] #compute beta's
     #print(paste("iKK= ",eval(iKK)," j=",eval(j),"  beta= ",eval(betas[j]),sep=""))
   }
  jbest = selectbetaP1new(cc,x,y,betas)
  #print("  select var",eval(jbest),"  coef=", round(eval(betas[jbest]),4), " diff=", round(eval(odiff),5), sep=""))
  selectvar[iKK,1] = jbest
  selectvar[iKK,2] = betas[jbest]
  cc = cc-y*x[,jbest]*betas[jbest]

  newobj = sum(pmax(cc,0))
  odiff = newobj-oldobj
  oldobj = newobj
  iKK = iKK+1
  }
  #print(paste("total numer of iterations",eval(iKK),sep=" "))

  #beta0 = sbeta0P1(cc,y)[[1]] #update b0 one more time
  #print(paste("iKK= ",eval(iKK),"  obj diff=",eval(odiff),sep=""))
   
  #refit step
  sid1 <- sort(unique(selectvar[selectvar[,1]>0,1])) #selected variables index
  size1 <- length(sid1)
  value1 <- rep(0,size1) #the collected coefficients for selected variables
  freq1 <- rep(0,size1)  #the selection frequency for selected variables
  for (j in 1:size1)
    {value1[j]=sum(selectvar[selectvar[,1]==sid1[j],2])
     freq1[j] = sum(sid1[j]==selectvar[,1])
    } 

  xx <- as.matrix(x[,sid1])
  #init1 <- c(beta0,value1)
  #refitff <- optim(init1,fobj1,gr=NULL,ylab=y,xinput=xx, tau1=lama1, method="BFGS")
  #refits <- refitff$par
  #refitobj <- refitff$value

  svmfit1 <- svmpath(xx,y)
  if (lama1<min(svmfit1$lambda))
   {svmpred1 <- predict(svmfit1,lambda=min(svmfit1$lambda)+myeps,type="alpha") }
  if (lama1>max(svmfit1$lambda))
   {svmpred1 <- predict(svmfit1,lambda=max(svmfit1$lambda)+myeps,type="alpha")}
  if (lama1>=min(svmfit1$lambda) & lama1<=max(svmfit1$lambda) ) 
   {svmpred1 <- predict(svmfit1,lambda=lama1,type="alpha") }
  alphas1 <- svmpred1$alpha
  selectvar[M+1,2]=svmpred1$alpha0
  refits <- t(xx)%*%(alphas1*y)

  for (ii in 1:(size1))
    { idd = sid1[ii]
      selectvar[selectvar[,1]==idd,2]=refits[ii]/freq1[ii]
    }
  return(selectvar)
}
